----------------------------------------------------------------------------------
-- Company: CS
-- PhD Student: MAW
-- 
-- Create Date: 12.02.2016 16:41:23
-- Design Name: 
-- Module Name: decode_waypoint - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: v20xxx
-- Description: Waypoint packet of PFT protocol
-- 
-- Dependencies: None
-- 
-- Revision: Not tracking
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
-- PFT trace decoder
-- 3rd version
-- Decode trace generated by PTM and recovered in the PL through TPIU (Trace Port Interface Unit)
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

use std.textio.all;
use std.env.all;

entity testbench_contextid is
end entity;

architecture test1 of testbench_contextid is
signal data_in : std_logic_vector(7 downto 0) := (others => '0');
signal clk : std_logic := '0';
signal reset : std_logic;
signal enable, fifo_overflow : std_logic;
signal pc  : std_logic_vector(31 downto 0) := (others => '0');
signal w_en, w_ctxt_en, rd_en : std_logic;
signal waypoint_address, context_id: std_logic_vector(31 downto 0);
signal waypoint_address_en : std_logic;
signal count : std_logic_vector(9 downto 0);

type array_slv is array(natural range<>) of std_logic_vector(31 downto 0);
constant expected_result_pc : array_slv := (
X"00010574",
X"00010428",
X"00010584",
X"000103c8",
X"00010598",
X"000103f8",
X"00010574",
X"00010428",
X"00010584",
X"000103c8",
X"00010598",
X"000103e0",
X"0001059c",
X"000105d4",
X"000103d4",
X"000105e8",
X"00010600",
X"000103ec",
X"00010614",
X"00010434",
X"0001061c",
X"000103c8"
);

constant expected_result_context_id : array_slv :=(
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d242",
X"0004d340",
X"0004d340",
X"0004d340",
X"0004d340"
);


-- functions declaration
-- converts an integer into a character
   -- for 0 to 9 the obvious mapping is used, higher
   -- values are mapped to the characters A-Z
   -- (this is usefull for systems with base > 10)
   -- (adapted from Steve Vogwell's posting in comp.lang.vhdl)

   function chr(int: integer) return character is
    variable c: character;
   begin
        case int is
          when  0 => c := '0';
          when  1 => c := '1';
          when  2 => c := '2';
          when  3 => c := '3';
          when  4 => c := '4';
          when  5 => c := '5';
          when  6 => c := '6';
          when  7 => c := '7';
          when  8 => c := '8';
          when  9 => c := '9';
          when 10 => c := 'A';
          when 11 => c := 'B';
          when 12 => c := 'C';
          when 13 => c := 'D';
          when 14 => c := 'E';
          when 15 => c := 'F';
          when 16 => c := 'G';
          when 17 => c := 'H';
          when 18 => c := 'I';
          when 19 => c := 'J';
          when 20 => c := 'K';
          when 21 => c := 'L';
          when 22 => c := 'M';
          when 23 => c := 'N';
          when 24 => c := 'O';
          when 25 => c := 'P';
          when 26 => c := 'Q';
          when 27 => c := 'R';
          when 28 => c := 'S';
          when 29 => c := 'T';
          when 30 => c := 'U';
          when 31 => c := 'V';
          when 32 => c := 'W';
          when 33 => c := 'X';
          when 34 => c := 'Y';
          when 35 => c := 'Z';
          when others => c := '?';
        end case;
        return c;
    end chr;

   -- convert integer to string using specified base
   -- (adapted from Steve Vogwell's posting in comp.lang.vhdl)

   function str(int: integer; base: integer) return string is

    variable temp:      string(1 to 10);
    variable num:       integer;
    variable abs_int:   integer;
    variable len:       integer := 1;
    variable power:     integer := 1;

   begin

    -- bug fix for negative numbers
    abs_int := abs(int);

    num     := abs_int;

    while num >= base loop                     -- Determine how many
      len := len + 1;                          -- characters required
      num := num / base;                       -- to represent the
    end loop ;                                 -- number.

    for i in len downto 1 loop                 -- Convert the number to
      temp(i) := chr(abs_int/power mod base);  -- a string starting
      power := power * base;                   -- with the right hand
    end loop ;                                 -- side.

    -- return result and add sign if required
    if int < 0 then
       return '-'& temp(1 to len);
     else
       return temp(1 to len);
    end if;

   end str;

  -- convert integer to string, using base 10
  function str(int: integer) return string is

   begin

    return str(int, 10) ;

   end str;


-- converts std_logic into a character

   function chr(sl: std_logic) return character is
    variable c: character;
    begin
      case sl is
         when 'U' => c:= 'U';
         when 'X' => c:= 'X';
         when '0' => c:= '0';
         when '1' => c:= '1';
         when 'Z' => c:= 'Z';
         when 'W' => c:= 'W';
         when 'L' => c:= 'L';
         when 'H' => c:= 'H';
         when '-' => c:= '-';
      end case;
    return c;
end chr;


function str(slv: std_logic_vector) return string is
     variable result : string (1 to slv'length);
     variable r : integer;
   begin
     r := 1;
     for i in slv'range loop
        result(r) := chr(slv(i));
        r := r + 1;
     end loop;
     return result;
   end str;


-- component declaration
component decodeur_traces
generic (ctxtid_bits : std_logic_vector(1 downto 0) := "11");
port(
clk, reset, enable : in std_logic;
trace_data : in std_logic_vector(7 downto 0);
pc : out std_logic_vector(31 downto 0);
w_en, w_ctxt_en, fifo_overflow : out std_logic;
waypoint_address, context_id : out std_logic_vector(31 downto 0);
waypoint_address_en : out std_logic
);
end component;

begin
u1: decodeur_traces generic map(ctxtid_bits => "11")
    port map (
	clk,reset, enable, data_in, pc, w_en, w_ctxt_en, fifo_overflow, waypoint_address, context_id, waypoint_address_en
	);

clock_tic: process
begin
--wait for 1 ns;
loop
clk <= '1'; wait for 5 ns;
clk <= '0'; wait for 5 ns;
end loop;
end process;
--clk <= not clk after 5 ns;

input_changes : process
begin
count <= "0000000000" after 0 ns,
"0000000001" after 40 ns,
"0010000000" after 100 ns;

reset <= '1' after 0 ns, 
         '0' after 170 ns;
enable <= '0' after 0 ns,
--          '1' after 170 ns, '0' after 365 ns, '1' after 385 ns;
          '1' after 170 ns, '1' after 365 ns, '1' after 385 ns; 
data_in <= 
X"00" after 175 ns,
X"00" after 185 ns,
X"00" after 195 ns,
X"00" after 205 ns,
X"00" after 215 ns,
X"00" after 225 ns,
X"00" after 235 ns,
X"00" after 245 ns,
X"00" after 255 ns,
X"4f" after 265 ns,
X"14" after 275 ns,
X"00" after 285 ns,
X"00" after 295 ns,
X"00" after 305 ns,
X"00" after 315 ns,
X"00" after 325 ns,
X"80" after 335 ns,
X"08" after 345 ns,
X"a0" after 355 ns,
X"55" after 365 ns,
X"01" after 375 ns,
X"00" after 385 ns,
X"21" after 395 ns,
X"26" after 405 ns,
X"73" after 415 ns,
X"04" after 425 ns,
X"00" after 435 ns,
X"c7" after 445 ns,
X"10" after 455 ns,
X"ed" after 465 ns,
X"8c" after 475 ns,
X"02" after 485 ns,
X"9b" after 495 ns,
X"06" after 505 ns,
X"dd" after 515 ns,
X"cf" after 525 ns,
X"02" after 535 ns,
X"72" after 545 ns,
X"73" after 555 ns,
X"85" after 565 ns,
X"80" after 575 ns,
X"fe" after 585 ns,
X"ff" after 595 ns,
x"62" after 575 ns,
x"01" after 585 ns,
x"00" after 595 ns,
X"4f" after 605 ns,
X"14" after 615 ns,
--X"08" after 625 ns,
--X"e8" after 635 ns,
--X"4f" after 645 ns,
--X"01" after 655 ns,
--X"00" after 665 ns,
--X"21" after 675 ns,
--X"26" after 685 ns,
--X"73" after 695 ns,
--X"04" after 705 ns,
--X"00" after 715 ns,
--X"ed" after 725 ns,
--X"8c" after 735 ns,
--X"02" after 745 ns,
--X"f7" after 755 ns,
--X"cf" after 765 ns,
--X"02" after 775 ns,
--X"a7" after 785 ns,
--X"86" after 795 ns,
--X"02" after 805 ns,
--X"85" after 815 ns,
--X"d0" after 825 ns,
--X"02" after 835 ns,
--X"93" after 845 ns,
--X"0f" after 855 ns,
--X"0b" after 865 ns,
--X"c1" after 875 ns,
--X"15" after 885 ns,
x"08"  after 625 ns,
x"80"  after 635 ns,
x"63"  after 645 ns,
x"01"  after 655 ns,
x"00"  after 665 ns,
x"21"  after 675 ns,
x"a7"  after 685 ns,
x"d8"  after 695 ns,
x"04"  after 705 ns,
x"00"  after 715 ns,
x"49"  after 725 ns,
x"fb"  after 735 ns,
x"21"  after 745 ns,
x"72"  after 755 ns,
x"a5"  after 765 ns,
x"22"  after 775 ns,
x"85"  after 785 ns,
x"80"  after 795 ns,
x"fe"  after 805 ns,
x"ff"  after 815 ns,
x"4f"  after 825 ns,
x"14"  after 835 ns,
x"08"  after 845 ns,
x"4c"  after 855 ns,
x"62"  after 865 ns,
x"01"  after 875 ns,
x"00"  after 885 ns,
X"a3" after 1075 ns,
X"10" after 1085 ns,
X"ed" after 1095 ns,
X"8c" after 1105 ns,
X"02" after 1115 ns,
X"b1" after 1125 ns,
X"06" after 1135 ns,
X"b3" after 1145 ns,
X"ca" after 1155 ns,
X"02" after 1165 ns,
X"bf" after 1175 ns,
X"1e" after 1185 ns,
X"65" after 1195 ns,
X"e3" after 1205 ns,
X"0a" after 1215 ns,
X"d5" after 1225 ns,
X"15" after 1235 ns,
X"86" after 1245 ns,
X"6d" after 1255 ns,
X"86" after 1265 ns,
X"73" after 1275 ns,
X"77" after 1285 ns,
X"86" after 1295 ns,
X"81" after 1305 ns,
X"16" after 1315 ns,
X"11" after 1325 ns,
X"91" after 1335 ns,
X"17" after 1345 ns,
X"1d" after 1355 ns,
X"39" after 1365 ns,
X"91" after 1375 ns,
X"18" after 1385 ns,
X"86" after 1395 ns,
X"19" after 1405 ns,
X"86" after 1415 ns,
X"27" after 1425 ns,
X"2f" after 1435 ns,
X"86" after 1445 ns,
X"3b" after 1455 ns,
X"4b" after 1465 ns,
X"86" after 1475 ns,
X"57" after 1485 ns,
X"5d" after 1495 ns,
X"93" after 1505 ns,
X"1c" after 1515 ns,
X"e1" after 1525 ns,
X"1d" after 1535 ns,
X"86" after 1545 ns,
X"73" after 1555 ns,
X"a5" after 1565 ns,
X"1e" after 1575 ns,
X"ef" after 1585 ns,
X"0a" after 1595 ns,
X"85" after 1605 ns,
X"0b" after 1615 ns,
X"b9" after 1625 ns,
X"86" after 1635 ns,
X"02" after 1645 ns,
X"47" after 1655 ns,
X"a3" after 1665 ns,
X"cf" after 1675 ns,
X"02" after 1685 ns,
X"1b" after 1695 ns,
X"31" after 1705 ns,
X"13" after 1715 ns,
X"0b" after 1725 ns,
X"c1" after 1735 ns,
X"15" after 1745 ns,
X"72" after 1755 ns,
X"4f" after 1765 ns,
X"85" after 1775 ns,
X"80" after 1785 ns,
X"fe" after 1795 ns,
X"ff" after 1805 ns,
X"4f" after 1815 ns,
X"14" after 1825 ns,
X"08" after 1835 ns,
X"a0" after 1845 ns,
X"55" after 1855 ns,
X"01" after 1865 ns,
X"00" after 1875 ns,
X"21" after 1885 ns,
X"26" after 1895 ns,
X"73" after 1905 ns,
X"04" after 1915 ns,
X"00" after 1925 ns,
X"c3" after 1935 ns,
X"0f" after 1945 ns,
X"ed" after 1955 ns,
X"8c" after 1965 ns,
X"02" after 1975 ns,
X"cb" after 1985 ns,
X"06" after 1995 ns,
X"59" after 2005 ns,
X"83" after 2015 ns,
X"0a" after 2025 ns,
X"99" after 2035 ns,
X"07" after 2045 ns,
X"8d" after 2055 ns,
X"cd" after 2065 ns,
X"02" after 2075 ns,
X"86" after 2085 ns,
X"1d" after 2095 ns,
X"86" after 2105 ns,
X"29" after 2115 ns,
X"86" after 2125 ns,
X"37" after 2135 ns,
X"86" after 2145 ns,
X"41" after 2155 ns,
X"86" after 2165 ns,
X"5f" after 2175 ns,
X"86" after 2185 ns,
X"6d" after 2195 ns,
X"72" after 2205 ns,
X"6d" after 2215 ns,
X"83" after 2225 ns,
X"80" after 2235 ns,
X"fe" after 2245 ns,
X"ff" after 2255 ns,
X"4f" after 2265 ns,
X"12" after 2275 ns,
X"08" after 2285 ns,
X"d8" after 2295 ns,
X"4d" after 2305 ns,
X"01" after 2315 ns,
X"00" after 2325 ns,
X"21" after 2335 ns,
X"26" after 2345 ns,
X"73" after 2355 ns,
X"04" after 2365 ns,
X"00" after 2375 ns,
X"86" after 2385 ns,
X"8b" after 2395 ns,
X"0e" after 2405 ns,
X"0b" after 2415 ns,
X"0b" after 2425 ns,
X"0b" after 2435 ns,
X"86" after 2445 ns,
X"1b" after 2455 ns,
X"b3" after 2465 ns,
X"87" after 2475 ns,
X"02" after 2485 ns,
X"3b" after 2495 ns,
X"3b" after 2505 ns,
X"3b" after 2515 ns,
X"3b" after 2525 ns,
X"3b" after 2535 ns,
X"3b" after 2545 ns,
X"3b" after 2555 ns,
X"3b" after 2565 ns,
X"3b" after 2575 ns,
X"3b" after 2585 ns,
X"3b" after 2595 ns,
X"3b" after 2605 ns,
X"3b" after 2615 ns,
X"86" after 2625 ns,
X"43" after 2635 ns,
X"86" after 2645 ns,
X"51" after 2655 ns,
X"51" after 2665 ns,
X"51" after 2675 ns,
X"51" after 2685 ns,
X"51" after 2695 ns,
X"51" after 2705 ns,
X"51" after 2715 ns,
X"51" after 2725 ns,
X"51" after 2735 ns,
X"51" after 2745 ns,
X"51" after 2755 ns,
X"51" after 2765 ns,
X"51" after 2775 ns,
X"51" after 2785 ns,
X"51" after 2795 ns,
X"51" after 2805 ns,
X"51" after 2815 ns,
X"51" after 2825 ns,
X"86" after 2835 ns,
X"61" after 2845 ns,
X"71" after 2855 ns,
X"86" after 2865 ns,
X"85" after 2875 ns,
X"08" after 2885 ns,
X"19" after 2895 ns,
X"27" after 2905 ns,
X"15" after 2915 ns,
X"19" after 2925 ns,
X"86" after 2935 ns,
X"21" after 2945 ns,
X"15" after 2955 ns,
X"19" after 2965 ns,
X"86" after 2975 ns,
X"21" after 2985 ns,
X"15" after 2995 ns,
X"19" after 3005 ns,
X"86" after 3015 ns,
X"21" after 3025 ns,
X"15" after 3035 ns,
X"19" after 3045 ns,
X"86" after 3055 ns,
X"21" after 3065 ns,
X"15" after 3075 ns,
X"19" after 3085 ns,
X"27" after 3095 ns,
X"15" after 3105 ns,
X"19" after 3115 ns,
X"86" after 3125 ns,
X"21" after 3135 ns,
X"15" after 3145 ns,
X"19" after 3155 ns,
X"86" after 3165 ns,
X"21" after 3175 ns,
X"15" after 3185 ns,
X"19" after 3195 ns,
X"86" after 3205 ns,
X"21" after 3215 ns,
X"15" after 3225 ns,
X"19" after 3235 ns,
X"86" after 3245 ns,
X"21" after 3255 ns,
X"15" after 3265 ns,
X"19" after 3275 ns,
X"27" after 3285 ns,
X"15" after 3295 ns,
X"19" after 3305 ns,
X"86" after 3315 ns,
X"21" after 3325 ns,
X"15" after 3335 ns,
X"19" after 3345 ns,
X"86" after 3355 ns,
X"21" after 3365 ns,
X"15" after 3375 ns,
X"19" after 3385 ns,
X"86" after 3395 ns,
X"21" after 3405 ns,
X"15" after 3415 ns,
X"19" after 3425 ns,
X"86" after 3435 ns,
X"21" after 3445 ns,
X"15" after 3455 ns,
X"19" after 3465 ns,
X"86" after 3475 ns,
X"21" after 3485 ns,
X"15" after 3495 ns,
X"19" after 3505 ns,
X"86" after 3515 ns,
X"21" after 3525 ns,
X"15" after 3535 ns,
X"19" after 3545 ns
;
--X"00" after 175 ns,
--X"00" after 185 ns,
--X"00" after 195 ns,
--X"00" after 205 ns,
--X"00" after 215 ns,
--X"80" after 225 ns,
--X"08" after 235 ns,
--X"74" after 245 ns,
--X"05" after 255 ns,
--X"01" after 265 ns,
--X"00" after 275 ns,
--X"21" after 285 ns,
--X"42" after 295 ns,
--X"d2" after 305 ns,
--X"04" after 315 ns,
--X"00" after 325 ns,
--X"95" after 335 ns,
--X"04" after 345 ns,
--X"08" after 355 ns,
--X"00" after 365 ns,
--X"00" after 375 ns,
--X"84" after 385 ns,
--X"05" after 395 ns,
--X"01" after 405 ns,
--X"00" after 415 ns,
--X"21" after 425 ns,
--X"42" after 435 ns,
--X"d2" after 445 ns,
--X"04" after 455 ns,
--X"00" after 465 ns,
--X"e5" after 475 ns,
--X"03" after 485 ns,
--X"08" after 495 ns,
--X"98" after 505 ns,
--X"05" after 515 ns,
--X"01" after 525 ns,
--X"00" after 535 ns,
--X"21" after 545 ns,
--X"42" after 555 ns,
--X"d2" after 565 ns,
--X"04" after 575 ns,
--X"00" after 585 ns,
--X"fd" after 595 ns,
--X"03" after 605 ns,
--X"08" after 615 ns,
--X"74" after 625 ns,
--X"05" after 635 ns,
--X"01" after 645 ns,
--X"00" after 655 ns,
--X"21" after 665 ns,
--X"40" after 675 ns,
--X"d3" after 685 ns,
--X"04" after 695 ns,
--X"00" after 705 ns,
--X"95" after 715 ns,
--X"04" after 725 ns,
--X"08" after 735 ns,
--X"84" after 745 ns,
--X"05" after 755 ns,
--X"01" after 765 ns,
--X"00" after 775 ns,
--X"21" after 785 ns,
--X"40" after 795 ns,
--X"d3" after 805 ns,
--X"04" after 815 ns,
--X"00" after 825 ns,
--X"e5" after 835 ns,
--X"03" after 845 ns,
--X"08" after 855 ns,
--X"98" after 865 ns,
--X"05" after 875 ns,
--X"01" after 885 ns,
--X"00" after 895 ns,
--X"21" after 905 ns,
--X"40" after 915 ns,
--X"d3" after 925 ns,
--X"04" after 935 ns,
--X"00" after 945 ns,
--X"f1" after 955 ns,
--X"03" after 965 ns,
--X"08" after 975 ns,
--X"9c" after 985 ns,
--X"05" after 995 ns,
--X"01" after 1005ns,
--X"00" after 1015ns,
--X"21" after 1025 ns,
--X"40" after 1035 ns,
--X"d3" after 1045 ns,
--X"04" after 1055 ns,
--X"00" after 1065 ns,
--X"6b" after 1075 ns,
--X"eb" after 1085 ns,
--X"03" after 1095 ns,
--X"08" after 1105 ns,
--X"e8" after 1115 ns,
--X"05" after 1125 ns,
--X"01" after 1135 ns,
--X"00" after 1145 ns,
--X"21" after 1155 ns,
--X"40" after 1165 ns,
--X"d3" after 1175 ns,
--X"04" after 1185 ns,
--X"00" after 1195 ns,
--X"81" after 1205 ns,
--X"06" after 1215 ns,
--X"f7" after 1225 ns,
--X"03" after 1235 ns,
--X"08" after 1245 ns,
--X"14" after 1255 ns,
--X"06" after 1265 ns,
--X"01" after 1275 ns,
--X"00" after 1285 ns,
--X"21" after 1295 ns,
--X"40" after 1305 ns,
--X"d3" after 1315 ns,
--X"04" after 1325 ns,
--X"00" after 1335 ns,
--X"9b" after 1345 ns,
--X"04" after 1355 ns,
--X"08" after 1365 ns,
--X"1c" after 1375 ns,
--X"06" after 1385 ns,
--X"01" after 1395 ns,
--X"00" after 1405 ns,
--X"21" after 1415 ns,
--X"40" after 1425 ns,
--X"d3" after 1435 ns,
--X"04" after 1445 ns,
--X"00" after 1455 ns,
--X"e5" after 1465 ns,
--X"03" after 1475 ns,
--X"08" after 1485 ns,
--X"30" after 1495 ns,
--X"06" after 1505 ns,
--X"01" after 1515 ns,
--X"00" after 1525 ns,
--X"21" after 1535 ns,
--X"40" after 1545 ns,
--X"d3" after 1555 ns,
--X"04" after 1565 ns,
--X"00" after 1575 ns,
--X"fd" after 1585 ns,
--X"03" after 1595 ns,
--X"08" after 1605 ns,
--X"9c" after 1615 ns,
--X"05" after 1625 ns,
--X"01" after 1635 ns,
--X"00" after 1645 ns,
--X"21" after 1655 ns,
--X"42" after 1665 ns,
--X"d2" after 1675 ns,
--X"04" after 1685 ns,
--X"00" after 1695 ns,
--X"86" after 1705 ns,
--X"83" after 1715 ns,
--X"04" after 1725 ns,
--X"08" after 1735 ns,
--X"b8" after 1745 ns,
--X"05" after 1755 ns,
--X"01" after 1765 ns,
--X"00" after 1775 ns,
--X"21" after 1785 ns,
--X"42" after 1795 ns,
--X"d2" after 1805 ns,
--X"04" after 1815 ns,
--X"00" after 1825 ns,
--X"f1" after 1835 ns,
--X"03" after 1845 ns,
--X"08" after 1855 ns,
--X"bc" after 1865 ns,
--X"05" after 1875 ns,
--X"01" after 1885 ns,
--X"00" after 1895 ns,
--X"21" after 1905 ns,
--X"42" after 1915 ns,
--X"d2" after 1925 ns,
--X"04" after 1935 ns,
--X"00" after 1945 ns,
--X"7b" after 1955 ns,
--X"eb" after 1965 ns,
--X"03" after 1975 ns,
--X"08" after 1985 ns,
--X"08" after 1995 ns,
--X"06" after 2005 ns,
--X"01" after 2015 ns,
--X"00" after 2025 ns,
--X"21" after 2035 ns,
--X"42" after 2045 ns,
--X"d2" after 2055 ns,
--X"04" after 2065 ns,
--X"00" after 2075 ns,
--X"11" after 2085 ns,
--X"f7" after 2095 ns,
--X"03" after 2105 ns,
--X"08" after 2115 ns,
--X"34" after 2125 ns,
--X"06" after 2135 ns,
--X"01" after 2145 ns,
--X"00" after 2155 ns,
--X"21" after 2165 ns,
--X"42" after 2175 ns,
--X"d2" after 2185 ns,
--X"04" after 2195 ns,
--X"00" after 2205 ns,
--X"9b" after 2215 ns,
--X"04" after 2225 ns,
--X"08" after 2235 ns,
--X"3c" after 2245 ns,
--X"06" after 2255 ns,
--X"01" after 2265 ns,
--X"00" after 2275 ns,
--X"21" after 2285 ns,
--X"42" after 2295 ns,
--X"d2" after 2305 ns,
--X"04" after 2315 ns,
--X"00" after 2325 ns,
--X"e5" after 2335 ns,
--X"03" after 2345 ns,
--X"08" after 2355 ns,
--X"50" after 2365 ns,
--X"06" after 2375 ns,
--X"01" after 2385 ns,
--X"00" after 2395 ns,
--X"21" after 2405 ns,
--X"42" after 2415 ns,
--X"d2" after 2425 ns,
--X"04" after 2435 ns,
--X"00" after 2445 ns,
--X"95" after 2455 ns,
--X"04" after 2465 ns,
--X"08" after 2475 ns,
--X"54" after 2485 ns,
--X"06" after 2495 ns,
--X"01" after 2505 ns,
--X"00" after 2515 ns,
--X"21" after 2525 ns,
--X"42" after 2535 ns,
--X"d2" after 2545 ns,
--X"04" after 2555 ns,
--X"00" after 2565 ns,
--X"e5" after 2575 ns,
--X"03" after 2585 ns,
--X"08" after 2595 ns,
--X"68" after 2605 ns,
--X"06" after 2615 ns,
--X"01" after 2625 ns,
--X"00" after 2635 ns,
--X"21" after 2645 ns,
--X"42" after 2655 ns,
--X"d2" after 2665 ns,
--X"04" after 2675 ns,
--X"00" after 2685 ns,
--X"fd" after 2695 ns,
--X"ac" after 2705 ns,
--X"b8" after 2715 ns,
--X"db" after 2725 ns,
--X"0d" after 2735 ns,
--X"08" after 2745 ns,
--X"34" after 2755 ns,
--X"06" after 2765 ns,
--X"01" after 2775 ns,
--X"00" after 2785 ns,
--X"21" after 2795 ns,
--X"40" after 2805 ns,
--X"d3" after 2815 ns,
--X"04" after 2825 ns,
--X"00" after 2835 ns,
--X"86" after 2845 ns,
--X"83" after 2855 ns,
--X"04" after 2865 ns,
--X"08" after 2875 ns,
--X"50" after 2885 ns,
--X"06" after 2895 ns,
--X"01" after 2905 ns,
--X"00" after 2915 ns,
--X"21" after 2925 ns,
--X"40" after 2935 ns,
--X"d3" after 2945 ns,
--X"04" after 2955 ns,
--X"00" after 2965 ns,
--X"95" after 2975 ns,
--X"04" after 2985 ns,
--X"08" after 2995 ns,
--X"54" after 3005 ns,
--X"06" after 3015 ns,
--X"01" after 3025 ns,
--X"00" after 3035 ns,
--X"21" after 3045 ns,
--X"40" after 3055 ns,
--X"d3" after 3065 ns,
--X"04" after 3075 ns,
--X"00" after 3085 ns,
--X"e5" after 3095 ns,
--X"03" after 3105 ns,
--X"08" after 3115 ns,
--X"68" after 3125 ns,
--X"06" after 3135 ns,
--X"01" after 3145 ns,
--X"00" after 3155 ns,
--X"21" after 3165 ns,
--X"40" after 3175 ns,
--X"d3" after 3185 ns,
--X"04" after 3195 ns,
--X"00" after 3205 ns,
--X"fd" after 3215 ns,
--X"dc" after 3225 ns,
--X"cc" after 3235 ns,
--X"db" after 3245 ns,
--X"0d" after 3255 ns,
--X"01" after 3265 ns,
--X"00" after 3275 ns,
--X"00" after 3285 ns,
--X"00" after 3295 ns,
--X"00" after 3305 ns,
--X"00" after 3315 ns,
--X"00" after 3325 ns,
--X"00" after 3335 ns,
--X"00" after 3345 ns,
--X"00" after 3355 ns,
--X"00" after 3365 ns,
--X"00" after 3375 ns,
--X"00" after 3385 ns,
--X"00" after 3395 ns,
--X"00" after 3405 ns,
--X"00" after 3415 ns,
--X"00" after 3425 ns,
--X"00" after 3435 ns,
--X"00" after 3445 ns,
--X"00" after 3455 ns,
--X"00" after 3465 ns,
--X"00" after 3475 ns,
--X"00" after 3485 ns,
--X"00" after 3495 ns,
--X"00" after 3505 ns,
--X"00" after 3515 ns,
--X"00" after 3525 ns,
--X"00" after 3535 ns,
--X"00" after 3545 ns
--;

wait;
end process;


Check_pc_process: process
variable log_line : line;
begin    
    for i in expected_result_pc'range loop
        wait until rising_edge(w_en); 
        write(log_line,
            "pc (i): " & str(i) &
            ", check: " & str(pc) &
            ", expected: " & str(expected_result_pc(i))
            );
        writeline(output, log_line); 
        assert pc = expected_result_pc(i); 
    end loop;

    report "End of Simulation (PC). All tests passed."; 
    --finish; 
end process; 


Check_context_id_process: process
variable log_line_2: line;
begin    
    for j in expected_result_pc'range loop
        wait until rising_edge(w_ctxt_en); 
        write(log_line_2,
            "context_id (i): " & str(j) &
            ", check: " & str(context_id) &
            ", expected: " & str(expected_result_context_id(j))
            );
        writeline(output, log_line_2); 
        assert context_id = expected_result_context_id(j); 
    end loop;
    report "End of Simulation (Context id). All tests passed." severity note; 
    finish; 
end process;


end test1;
